﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr196_1
{
    // Структура: 
    struct MyStruct {
        // Закрытое текстовое поле:
        private string txt;
        // Текстовое свойство: 
        public string text {
            // Аксессор для считывания значения свойства: 
            get {
                return txt;
            }
            // Аксессор для присваивания значения свойству: 
            set {
                txt = value;
            }
        }
        // Целочисленное свойство (доступно для чтения): 
        public int length {
            // Аксессор для считывания значения свойства: 
            get {
                return txt.Length;
            }
        }
        // Индексатор с целочисленным индексом: 
        public char this[int k] {
            // Аксессор для считывания значения: 
            get {
                return txt[k];
            }
            // Аксессор для присваивания значения: 
            set {
                // Преобразование текста в символьный массив: 
                char[] s = txt.ToCharArray();
                // Замена символа в массиве: 
                s[k] = value;
                // Преобразование массива в текст: 
                txt = new string(s);
            }
        }
    }

    // Класс с главным методом: 
    class Program
    { 
        // Главный метод:
        static void Main()
        {
            // Создание экземпляра структуры:
            MyStruct A = new MyStruct();
            // Присваивание значения текстовому свойству:
            A.text = "Alpha";
            // Проверка значения текстового свойства:
            Console.WriteLine(A.text);
            // Использование индексатора и 
            // целочисленного свойства:  
            for(int k = 0; k <A.length; k++) {
                Console.Write("|" + A[k]);
            }
            Console.WriteLine("|");
            // Использование индексатора и 
            // целочисленного свойства:
            A[0] = 'a';
            A[A.length - 1] = 'A';
            // Проверка значения текстового свойства:
            Console.WriteLine(A.text);
            // Задержка:
            Console.ReadLine();
        }
    }
}
